# -*- coding: utf-8 -*-

"""
    AliveGR radios Add-on
    Author: Twilight0/Thgiliwt

        This program is free software: you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation, either version 3 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program.  If not, see <http://www.gnu.org/licenses/>.
"""

import re, os, sys, base64
import urllib2, urlparse
import xbmcaddon, xbmcgui, xbmcplugin

# Commands:
join = os.path.join
addon = xbmcaddon.Addon()
localisedstr = addon.getLocalizedString
addonname = addon.getAddonInfo("name")
addonid = addon.getAddonInfo("id")
addonpath = addon.getAddonInfo("path")
addonfanart = addon.getAddonInfo("fanart")
addDirItems = xbmcplugin.addDirectoryItems
endDir = xbmcplugin.endOfDirectory
#addondesc = localisedstr(30000).encode("utf-8")
#datapath = xbmc.translatePath(addon.getAddonInfo("profile")).decode("utf-8")

# Artwork:
addonmedia = join(join(xbmcaddon.Addon('script.AliveGR.artwork').getAddonInfo('path'), 'resources', 'media'))

# Handlers:
addon_url = sys.argv[0]
addon_handle = int(sys.argv[1])
params = dict(urlparse.parse_qsl(sys.argv[2][1:]))
action = params.get('action', None)

# Playlist:
radio_urls = base64.b64decode('aHR0cDovL3RoZ2lsaXd0Lm9mZnNob3JlcGFzdGViaW4uY29tL3JhZGlvcy5tM3U=')


def requester(url):

    requester = urllib2.Request(url)
    requester.add_header('User-Agent', 'Mozilla/5.0 (Windows NT 6.3; rv:36.0) Gecko/20100101 Firefox/36.04')
    response = urllib2.urlopen(requester)
    result = response.read()
    response.close()

    return result


addons = [
    {
        'title': 'E-RADIO ADDON',
        'icon': 'http://i855.photobucket.com/albums/ab117/twilight-zero/Channel-Icons/ERADIO.png',
        'url': 'plugin://plugin.audio.eradio.gr/'
    },
    {
        'title': 'TUNE-IN ADDON',
        'icon': 'http://i855.photobucket.com/albums/ab117/twilight-zero/Channel-Icons/TUNE%20IN.png',
        'url': 'plugin://plugin.audio.tuneinradio/'
    }
]


def constructor(url=radio_urls):

    url = requester(url)
    items = re.compile('^#.+?:-?[0-9]* .+?="(.*?)",(.*?)\n(.*?)$', re.I + re.M + re.U + re.S).findall(url)

    cl = []

    for icon, title, url in items:
        data = {'title': title, 'icon': icon, 'url': url}
        cl.append(data)

    cl.extend(addons)

    return cl


def list_radios():

    radios = constructor()

    radio_list = []

    for radio in radios:
        li = xbmcgui.ListItem(label=radio['title'], iconImage=radio['icon'], thumbnailImage=radio['icon'])
        li.setInfo('music', {'title': radio['title']})
        li.setArt({'fanart': addonfanart})
        li.setProperty('IsPlayable', 'true')
        if radio['url'].startswith('plugin://'):
            url = radio['url']
            _isFolder = True
        else:
            url = '{0}?action=play&url={1}'.format(addon_url, radio['url'])
            _isFolder = False
        radio_list.append((url, li, _isFolder))
    addDirItems(addon_handle, radio_list)
    endDir(addon_handle)


def play_item(url):
    li = xbmcgui.ListItem(path=url)
    xbmcplugin.setResolvedUrl(addon_handle, True, listitem=li)


if action is None:
    list_radios()

elif action == 'play':
    play_item(params['url'])
